<% @Language="C#" validateRequest="false"%>
<% Response.ContentType = "text/javascript"; %>
<% 
string env = string.Empty;
if (!string.IsNullOrEmpty(Request.Params["env"]) && System.Text.RegularExpressions.Regex.IsMatch(Request.Params["env"], @"^[a-zA-Z0-9]+$"))
{
    env = Request.Params["env"];
}

DateTime d1 = new DateTime(1970, 1, 1);
DateTime d2 = DateTime.Now.ToUniversalTime();
TimeSpan ts = new TimeSpan(d2.Ticks - d1.Ticks);
double serverTime = Math.Round(ts.TotalMilliseconds);
%>
var element = window;

//Use this format: element\.[a-zA-Z0-9_]+
document.__campaignkeys = {"campaign":"utm_campaign", "source":"utm_source", "medium":"utm_medium", "content":"utm_content", "term":"utm_term"};
document.__refstoignore = "";

element.EventCollectorPath = "http://servername:port/EventCollector/monitor.aspx"; //OR "secured"
element.version = "2.0.3.0";
element.AgentName = "<%=env %> Agent";
element.TunnelPath = "http://servername:port/CardioLogAgent/tunnel.aspx";
element.AgentDirectory = "http://servername:port/CardioLogAgent";
element.HelpletFile = "";
element.AgentBaseLocation = "http://servername:port/CardioLogAgent/agentBaseEmbed.aspx";
element.Event_Visit = true;
element.Event_Leave = true;
element.Event_Search = true;
element.Event_SearchResultItem = false;
element.Event_SearchResultClick = true;
element.HelpletsEnabled = false;
element.Greedy = true;
element.MaxDuration = "1800000";
element.RefreshPeriod = "1";
element.SearchPeriod = "10";
element.SupportAnonymousUsers = true;
element.HandleFileExtension = true;
element.EnableConsole = true;
element.CustomAgentVersion = "1.2";
element.AgentEnvironmentVersion = "1.2";
element.AgentEnvironment = "<%=env %>";
element.BrowserType = "";
element.Param3ElementName = "";
element.verbose = false;
element.ClientServerTimeDifference = <%=serverTime%>- new Date().getTime();
element.EnableAltKey = true;
element.GetReferrerData = true;

function __trace(value) {
	if (element.verbose && typeof(console) != "undefined" && typeof(console.info) != "undefined") console.info(new Date()+","+value+","+document.location.href);
	//if (element.verbose && typeof(console) != "undefined" && typeof(console.info) != "undefined") console.info(getServerDate()+","+value+","+document.location.href);
//	else alert('no console or no verbose...');
}

function __saveCookie(name, value, days) {
	__trace("__saveCookie('"+name+"','"+value+"',"+days+");");
	if (days) {
		//var date = new Date();
		var date = getServerDate();
		date.setTime(date.getTime()+(days*24*60*60*1000))
		var expires = "; expires="+date.toGMTString()
	} else expires = "";
	document.cookie = name+"="+value+expires+"; path=/"
}
function __readCookie(name) {
    __trace("__readCookie('"+name+"');");
	name += "=";
	var cookieArr = document.cookie.split(';');
	for (var i=0;i<cookieArr.length;i++) {
		var c = cookieArr[i];
		while (c.substring(0,1) == ' ') c = c.substring(1, c.length)
		if (c.indexOf(name) == 0) return c.substring(name.length, c.length)
	}
	return null
}
function __deleteCookie(name) {
    __trace("__deleteCookie('"+name+"');");
	__saveCookie(name, "", -1)
}

var __alreadyLoaded = false;

function __init() {	
	__trace("__init");
	if (__alreadyLoaded) {
		__trace("already loaded");
		return;
	}
	
	if (element.BrowserType == "ie") {
		element.document.attachEvent("onkeydown", keydownmain);
	} else {
		element.document.addEventListener("keydown", keydownmain, false);
	}

	__alreadyLoaded = true;
	
	// load environment agent
	var script = document.createElement("script");
	if (element.BrowserType != "ie") {
		script.onload = function() {
			__trace(element.AgentDirectory+"/"+element.AgentEnvironment+"_"+element.AgentEnvironmentVersion+".js was loaded");
			__initEnvironmentAgent();
		}
	} else {
		script.onreadystatechange = function() {
			if (this.readyState == "loaded" || this.readyState == "complete") {
				__trace(element.AgentDirectory+"/"+element.AgentEnvironment+"_"+element.AgentEnvironmentVersion+".js was loaded");
				__initEnvironmentAgent();
			} else __trace(element.AgentDirectory+"/"+element.AgentEnvironment+"_"+element.AgentEnvironmentVersion+".js was not loaded yet ("+this.readyState+")");
		}
	}
	__trace("loading "+element.AgentDirectory+"/"+element.AgentEnvironment+"_"+element.AgentEnvironmentVersion+".js");
	script.src = element.AgentDirectory+"/"+element.AgentEnvironment+"_"+element.AgentEnvironmentVersion+".js";
	document.body.appendChild(script);
	script = null;
}

function GetUsername() {
	__trace("GetUsername");
	var currentUsername = __readCookie("userid");
	var useridInput = this.document.getElementById("userid");
	if (useridInput)
		currentUsername = useridInput.value;
	else if (currentUsername == null)
		currentUsername = "Anonymous_"+Math.random()*100000;

	__saveCookie("userid", currentUsername, 1000);
	__trace("GetUsername return: "+currentUsername);
	return currentUsername;
}

function GetParam3ElementValue() {
	__trace("GetParam3ElementValue");
	var currentParam3 = __readCookie("param3");
	var param3Input = this.document.getElementById(element.Param3ElementName);
	if (param3Input)
		currentParam3 = param3Input.value;
			
	__saveCookie("param3", currentParam3, 1000);
	__trace("GetParam3ElementValue return: "+currentParam3);
	return currentParam3;
}

function keydownmain(e) {
	e = (e) ? e : event;
	if ((typeof(element["EnableConsole"]) == "undefined" || element.EnableConsole) && (e.ctrlKey || e.altKey) && e.keyCode == 121) printDebug();
}
function printDebug() {
    var output = ""; for (var i=0;i<__Status.output.length;i++) { output += __Status.output[i].o+"\n";} prompt("", output);;
}

var __jsloaderInterval;

if (navigator.userAgent.match(/Safari/i)) {
	__trace("Safari browser");
	element.BrowserType = "safari";
	__jsloaderInterval = window.setInterval(function() {
							if(document.readyState == "loaded" || document.readyState == "complete") {
								__trace("Page is ready. execute __init");
								window.clearInterval(__jsloaderInterval);
								__init();
							} else __trace("Page is not ready. wait a bit more");}, 10);
} else if (document.addEventListener && !navigator.userAgent.match(/msie/i)) {
	__trace("FireFox browser");
	element.BrowserType = "ff";
	__trace("Attach __init to DOMContentLoaded");
	document.addEventListener("DOMContentLoaded", __init, false);
} else if (document.all && !window.opera) {
	__trace("IE browser");
	element.BrowserType = "ie";
	__jsloaderInterval = window.setInterval(function() {
							if(document.readyState == "loaded" || document.readyState == "complete") {
								__trace("Page is ready. execute __init");
								window.clearInterval(__jsloaderInterval);
								__init();
							} else __trace("Page is not ready. wait a bit more");}, 10);
}
if (document.addEventListener) {
	window.addEventListener("load", __init, false);
} else {
	window.attachEvent("onload", function() {
		window.clearInterval(__jsloaderInterval);
		__init();
	}); 
}